#include "Sigma.hpp"


vec Sigma::convert_freq_to_arma(){
    vec out(N);
    for(size_t i =0; i<N;i++){
        out(i) = wgrid[i];
    }
    return out;
}


vec Sigma::convert_SR_to_arma(){
    vec out(N);
    for(size_t i =0; i<N;i++){
        out(i) = Sig[i].real();
    }
    return out;
}


vec Sigma::convert_SI_to_arma(){
    vec out(N);
    for(size_t i =0; i<N;i++){
        out(i) = Sig[i].imag();
    }
    return out;
}

cd_vector Sigma::interpolation(d_vector w){
    vec SigmaR, SigmaI, new_w, vec_w;
    cd_vector Sig_int;
    Sig_int.reserve(w.size());
    cx_dl I(0,1.);
    reading::convert_vec_to_armavec(wgrid, vec_w);
    reading::convert_vec_to_armavec(w, new_w);
    interp1(vec_w, convert_SR_to_arma(), new_w, SigmaR);
    interp1(vec_w, convert_SI_to_arma(), new_w, SigmaI);

    for(size_t i =0; i <w.size();++i){
        Sig_int.push_back(SigmaR(i)+I*SigmaI(i));
    }
    SigmaR.reset();
    SigmaI.reset();
    new_w.reset();
    vec_w.reset();
    return Sig_int;
}

cx_dl Sigma::at(double w){
    vec SigmaR, SigmaI, vec_w;
    vec new_w(1);
    cx_dl Sig_int;
    cx_dl I(0,1.);
    reading::convert_vec_to_armavec(wgrid, vec_w);
    //reading::convert_vec_to_armavec(w, new_w);
    new_w(0) = w;
    interp1(vec_w, convert_SR_to_arma(), new_w, SigmaR, "*linear");
    interp1(vec_w, convert_SI_to_arma(), new_w, SigmaI, "*linear");
    Sig_int = SigmaR(0)+I*SigmaI(0);

    SigmaR.reset();
    SigmaI.reset();
    new_w.reset();
    vec_w.reset();
    return Sig_int;
}