
#ifndef Sigma_hpp
#define Sigma_hpp

#define _USE_MATH_DEFINES
#define ARMA_DONT_USE_WRAPPER

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <complex>
#include <vector>
#include "config.hpp"
#include <armadillo>
#include <assert.h>
#include "reading.hpp"
using namespace arma;

typedef std::complex<double> cx_dl;
typedef std::vector<double> d_vector;
typedef std::vector<cx_dl> cd_vector;


class Sigma{
    public:
    Sigma(){
        this-> N=0;
    };

    Sigma(d_vector w, cd_vector S){
        
        this->wgrid = w;
        this->Sig = S;
        assert(wgrid.size()==S.size());
        this-> N = wgrid.size();
    }
    void mod_values(d_vector w, cd_vector S){
    this-> wgrid= w;
    this-> Sig=S;
    assert(wgrid.size()==S.size());
    this->N = wgrid.size();
    }
    vec convert_freq_to_arma();
    vec convert_SR_to_arma();
    vec convert_SI_to_arma();
    cd_vector interpolation(d_vector new_w);
    cx_dl at(double w);

    private:
    d_vector wgrid;
    cd_vector Sig;
    int N;

};




#endif

