//
//  tools_C.hpp
//  Transport
//
//  Created by Shaheen Acheche on 29/09/2017.
//  Copyright © 2017 Shaheen Acheche. All rights reserved.
//

#ifndef reading_hpp
#define reading_hpp



#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <complex>
#include <vector>
#include <armadillo>


typedef std::complex<double> dcomp;
typedef std::vector<double> d_vector;
typedef std::vector<dcomp> cd_vector;

namespace reading {
cd_vector read_Self_up();
d_vector read_real_freq();
cd_vector read_Self_real();
template<typename T>
void convert_vec_to_armavec(std::vector<T> init, arma::Col<T> &fin){
    fin.set_size(init.size());
    for(size_t i = 0;i<init.size();++i){
        fin(i) = init[i];
    }
}
}
#endif

