
#ifndef tools_hpp
#define tools_hpp


#define ARMA_DONT_USE_WRAPPER

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <complex>
#include <vector>
#include <armadillo>
#include "Model.hpp"
#include <assert.h>

typedef std::complex<double> cx_dl;
typedef std::vector<double> d_vector;

d_vector linspace(double min, double max, int nbr, bool endpoint=false);
double dnFdw(const double beta, double w);
double Trace_integrande(model mod, const double w,const double eps, d_vector kgrid, d_vector kz);
double Trace_integrande(model mod, const double w,const double eps, d_vector kgrid);
double Trace_integrandeInt(model mod, const double w,const double eps, cx_dl S1, cx_dl S2, d_vector kgrid, d_vector kz);
double simps(d_vector y, d_vector x);
d_vector sigmaDC(model mod,d_vector wgrid,d_vector kgrid);
d_vector sigmaAC(model mod,double eps, d_vector wgrid,d_vector kgrid);
void get_boundary(const double beta, const double eps, double& wmin, double& wmax, double coeff=5);
double diff_nF(const double beta, const double w, const double eps);

#endif

